Package com.sas.rio

# Class MVADatabaseMetaData

java.lang.Object
com.sas.rio.MVADatabaseMetaData

All Implemented Interfaces:
  `DatabaseMetaData`, `Wrapper`

@SASScope("ALL") @NeedsAPIReview public class MVADatabaseMetaData extends Object implements DatabaseMetaData
This class provides information about the database as a whole.

Many of the methods here return lists of information in ResultSets. You can use the normal ResultSet methods such as getString and getInt to retrieve the data from these ResultSets. If a given form of metadata is not available, these methods should throw a SQLException.

Some of these methods take arguments that are String patterns. These arguments all have names such as fooPattern. Within a pattern String, "%" means match any substring of 0 or more characters, and "_" means match any one character. Only metadata entries matching the search pattern are returned. If a search pattern argument is set to a null ref, it means that argument's criteria should be dropped from the search.

A SQLException will be thrown if a driver does not support a meta data method. In the case of methods that return a ResultSet, either a ResultSet (which may be empty) is returned or a SQLException is thrown.

- ## Field Summary

  ### Fields inherited from interface java.sql.DatabaseMetaData

  `attributeNoNulls, attributeNullable, attributeNullableUnknown, bestRowNotPseudo, bestRowPseudo, bestRowSession, bestRowTemporary, bestRowTransaction, bestRowUnknown, columnNoNulls, columnNullable, columnNullableUnknown, functionColumnIn, functionColumnInOut, functionColumnOut, functionColumnResult, functionColumnUnknown, functionNoNulls, functionNoTable, functionNullable, functionNullableUnknown, functionResultUnknown, functionReturn, functionReturnsTable, importedKeyCascade, importedKeyInitiallyDeferred, importedKeyInitiallyImmediate, importedKeyNoAction, importedKeyNotDeferrable, importedKeyRestrict, importedKeySetDefault, importedKeySetNull, procedureColumnIn, procedureColumnInOut, procedureColumnOut, procedureColumnResult, procedureColumnReturn, procedureColumnUnknown, procedureNoNulls, procedureNoResult, procedureNullable, procedureNullableUnknown, procedureResultUnknown, procedureReturnsResult, sqlStateSQL, sqlStateSQL99, sqlStateXOpen, tableIndexClustered, tableIndexHashed, tableIndexOther, tableIndexStatistic, typeNoNulls, typeNullable, typeNullableUnknown, typePredBasic, typePredChar, typePredNone, typeSearchable, versionColumnNotPseudo, versionColumnPseudo, versionColumnUnknown`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `boolean`
  `allProceduresAreCallable()`
  Determines whether all stored procedures are callable.
  `boolean`
  `allTablesAreSelectable()`
  Determines whether all accessible tables are selectable.
  `boolean`
  `autoCommitFailureClosesAllResultSets()`
  `boolean`
  `dataDefinitionCausesTransactionCommit()`
  Determines whether a data definition statement within a transaction forces the transaction to commit.
  `boolean`
  `dataDefinitionIgnoredInTransactions()`
  Determines whether a data definition statement within a transaction is ignored.
  `boolean`
  `deletesAreDetected(int type)`
  JDBC 2.0 Determines whether or not a visible row delete can be detected by calling ResultSet.rowDeleted().
  `boolean`
  `doesMaxRowSizeIncludeBlobs()`
  Determines whether getMaxRowSize() includes LONGVARCHAR and LONGVARBINARY blobs.
  `boolean`
  `generatedKeyAlwaysReturned()`
  `ResultSet`
  `getAttributes(String catalog, String schemaPattern, String typeNamePattern, String attributeNamePattern)`
  Retrieves a description of the given attribute of the given type for a user-defined type (UDT) that is available in the given schema and catalog.
  `ResultSet`
  `getBestRowIdentifier(String catalog, String schema, String table, int scope, boolean nullable)`
  Retrieves a description of a table's optimal set of columns that uniquely identifies a row.
  `ResultSet`
  `getCatalogs()`
  Retrieves the catalog names available in this database.
  `String`
  `getCatalogSeparator()`
  Gets the separator that is being used between the catalog name and the table name.
  `String`
  `getCatalogTerm()`
  Gets the preferred term for "catalog".
  `ResultSet`
  `getClientInfoProperties()`
  The `MVADatabaseMetaData` implementation of `getClientInfoProperties` always returns an empty result set.
  `ResultSet`
  `getColumnPrivileges(String catalog, String schema, String table, String columnNamePattern)`
  Gets a description of the access rights for a table's columns.
  `ResultSet`
  `getColumns(String catalog, String schemaPattern, String tableNamePattern, String columnNamePattern)`
  Gets a description of table columns available in a catalog.
  `Connection`
  `getConnection()`
  JDBC 2.0 Gets the connection that produced this metadata object.
  `ResultSet`
  `getCrossReference(String primaryCatalog, String primarySchema, String primaryTable, String foreignCatalog, String foreignSchema, String foreignTable)`
  Gets a description of the foreign key columns in the foreign key table that reference the primary key columns of the primary key table.
  `int`
  `getDatabaseMajorVersion()`
  Retrieves the major version number of the underlying database.
  `int`
  `getDatabaseMinorVersion()`
  Retrieves the minor version number of the underlying database.
  `String`
  `getDatabaseProductName()`
  Gets the database product name.
  `String`
  `getDatabaseProductVersion()`
  Returns the version of the MVA server.
  `int`
  `getDefaultTransactionIsolation()`
  Gets the default transaction isolation level for the database.
  `int`
  `getDriverMajorVersion()`
  Retrieves this JDBC driver's major version number.
  `int`
  `getDriverMinorVersion()`
  Retrieves this JDBC driver's minor version number.
  `String`
  `getDriverName()`
  Retrieves the name of this JDBC driver.
  `String`
  `getDriverVersion()`
  Retrieves the version number of this JDBC driver as a `String` .
  `ResultSet`
  `getExportedKeys(String catalog, String schema, String table)`
  Gets a description of a foreign key columns that reference a table's primary key columns.
  `String`
  `getExtraNameCharacters()`
  `ResultSet`
  `getFunctionColumns(String catalog, String schemaPattern, String functionNamePattern, String columnNamePattern)`
  This method is not supported.
  `ResultSet`
  `getFunctions(String catalog, String schemaPattern, String functionNamePattern)`
  This method is not supported.
  `String`
  `getIdentifierQuoteString()`
  Gets the quote string that is used to surround quoted SQL identifiers.
  `ResultSet`
  `getImportedKeys(String catalog, String schema, String table)`
  Gets a description of the primary key columns that are referenced by a table's foreign key columns.
  `ResultSet`
  `getIndexInfo(String catalog, String schema, String table, boolean unique, boolean approximate)`
  Retrieves a description of the given table's indices and statistics.
  `int`
  `getJDBCMajorVersion()`
  Retrieves the major JDBC version number for this driver.
  `int`
  `getJDBCMinorVersion()`
  Retrieves the minor JDBC version number for this driver.
  `int`
  `getMaxBinaryLiteralLength()`
  Returns the number of hex characters that are allowed in an inline binary literal.
  `int`
  `getMaxCatalogNameLength()`
  Indicates the maximum length of a catalog name.
  `int`
  `getMaxCharLiteralLength()`
  Returns the maximum length of a character literal.
  `int`
  `getMaxColumnNameLength()`
  Returns the maximum length of a column name.
  `int`
  `getMaxColumnsInGroupBy()`
  Indicates the maximum number of columns that are allowed in a GROUP BY clause.
  `int`
  `getMaxColumnsInIndex()`
  Indicates the maximum number of columns that are allowed in an index.
  `int`
  `getMaxColumnsInOrderBy()`
  Indicates the maximum number of columns that are allowed in an ORDER BY clause.
  `int`
  `getMaxColumnsInSelect()`
  Determines the maximum number of columns that are allowed in a SELECT list.
  `int`
  `getMaxColumnsInTable()`
  Indicates the maximum number of columns that are allowed in a table.
  `int`
  `getMaxConnections()`
  Indicates the maximum number of database connections that can be active concurrently.
  `int`
  `getMaxCursorNameLength()`
  Indicates the maximum length of a cursor name.
  `int`
  `getMaxIndexLength()`
  Indicates the maximum size of an index (in bytes).
  `int`
  `getMaxProcedureNameLength()`
  Indicates the maximum length of a procedure name.
  `int`
  `getMaxRowSize()`
  Indicates the maximum length of a single row.
  `int`
  `getMaxSchemaNameLength()`
  Indicates the maximum length of a schema name.
  `int`
  `getMaxStatementLength()`
  Indicates the maximum length of an SQL statement.
  `int`
  `getMaxStatements()`
  Indicates the maximum number of active statements that can be open to this database concurrently.
  `int`
  `getMaxTableNameLength()`
  Indicates the maximum length of a table name.
  `int`
  `getMaxTablesInSelect()`
  Indicates the maximum number of tables in a SELECT list.
  `int`
  `getMaxUserNameLength()`
  Indicates the maximum length of a user name.
  `String`
  `getNumericFunctions()`
  `ResultSet`
  `getPrimaryKeys(String catalog, String schema, String table)`
  Retrieves a description of the given table's primary key columns.
  `ResultSet`
  `getProcedureColumns(String catalog, String schemaPattern, String procedureNamePattern, String columnNamePattern)`
  Gets a description of a catalog's stored procedure parameters and result columns.
  `ResultSet`
  `getProcedures(String catalog, String schemaPattern, String procedureNamePattern)`
  Get a description of stored procedures available in a catalog.
  `String`
  `getProcedureTerm()`
  Gets the preferred term for "procedure".
  `ResultSet`
  `getPseudoColumns(String arg0, String arg1, String arg2, String arg3)`
  `int`
  `getResultSetHoldability()`
  `RowIdLifetime`
  `getRowIdLifetime()`
  `ResultSet`
  `getSchemas()`
  Retrieves the schema names available in this database.
  `ResultSet`
  `getSchemas(String catalog, String schemaPattern)`
  `String`
  `getSchemaTerm()`
  Retrieves the database vendor's preferred term for "schema".
  `String`
  `getSearchStringEscape()`
  `String`
  `getSQLKeywords()`
  Gets a comma-delimited list of all database-specific SQL keywords that are not SQL92 keywords.
  `int`
  `getSQLStateType()`
  `String`
  `getStringFunctions()`
  `ResultSet`
  `getSuperTables(String catalog, String schemaPattern, String tableNamePattern)`
  Retrieves a description of the table hierarchies defined in a particular schema in this database.
  `ResultSet`
  `getSuperTypes(String catalog, String schemaPattern, String typeNamePattern)`
  Retrieves a description of the user-defined type (UDT) hierarchies defined in a particular schema in this database.
  `String`
  `getSystemFunctions()`
  `ResultSet`
  `getTablePrivileges(String catalog, String schemaPattern, String tableNamePattern)`
  Gets a description of the access rights each table available in a catalog.
  `ResultSet`
  `getTables(String catalog, String schemaPattern, String tableNamePattern, String[] types)`
  Gets a description of the tables that are available in a catalog.
  `ResultSet`
  `getTableTypes()`
  The `MVADatabaseMetaData` implementation of `DatabaseMetadata#getTables(String, String, String, String[])` always returns a result set containing "TABLE" and "VIEW".
  `String`
  `getTimeDateFunctions()`
  `ResultSet`
  `getTypeInfo()`
  Gets a description of all the standard SQL types supported by this database.
  `ResultSet`
  `getUDTs(String catalog, String schemaPattern, String typeNamePattern, int[] types)`
  JDBC 2.0 Gets a description of the user-defined types defined in a particular schema.
  `String`
  `getURL()`
  Gets the URL from the MVAConnection object.
  `String`
  `getUserName()`
  Gets the user name from the MVAConnection object.
  `ResultSet`
  `getVersionColumns(String catalog, String schema, String table)`
  Gets a description of the table columns that are automatically updated when any value in a row is updated.
  `boolean`
  `insertsAreDetected(int type)`
  JDBC 2.0 Determines whether or not a visible row insert can be detected by calling ResultSet.rowInserted().
  `boolean`
  `isCatalogAtStart()`
  Determines whether a catalog appears at the start of a qualified table name.
  `boolean`
  `isReadOnly()`
  Determines whether the connection is read-only.
  `boolean`
  `isWrapperFor(Class<?> iface)`
  `boolean`
  `locatorsUpdateCopy()`
  `boolean`
  `nullPlusNonNullIsNull()`
  `boolean`
  `nullsAreSortedAtEnd()`
  Determines whether NULLs are sorted at end.
  `boolean`
  `nullsAreSortedAtStart()`
  Determines whether NULLs are sorted at start.
  `boolean`
  `nullsAreSortedHigh()`
  Determines whether NULLs are sorted high.
  `boolean`
  `nullsAreSortedLow()`
  Determines whether NULLs are sorted low.
  `boolean`
  `othersDeletesAreVisible(int type)`
  JDBC 2.0 Determines whether changes made by others are visible.
  `boolean`
  `othersInsertsAreVisible(int type)`
  JDBC 2.0 Determines whether changes made by others are visible.
  `boolean`
  `othersUpdatesAreVisible(int type)`
  JDBC 2.0 Determines whether changes made by others are visible.
  `boolean`
  `ownDeletesAreVisible(int type)`
  JDBC 2.0 Determines whether a result set's own changes are visible.
  `boolean`
  `ownInsertsAreVisible(int type)`
  JDBC 2.0 Determines whether a result set's own changes are visible.
  `boolean`
  `ownUpdatesAreVisible(int type)`
  JDBC 2.0 Determines whether a result set's own changes are visible.
  `boolean`
  `storesLowerCaseIdentifiers()`
  Determines whether the database stores lowercase identifiers.
  `boolean`
  `storesLowerCaseQuotedIdentifiers()`
  Determines whether the database stores lowercase quoted SQL identifiers.
  `boolean`
  `storesMixedCaseIdentifiers()`
  Determines whether the database stores mixed-case identifiers.
  `boolean`
  `storesMixedCaseQuotedIdentifiers()`
  Determines whether the database stores mixed-case quoted SQL identifiers.
  `boolean`
  `storesUpperCaseIdentifiers()`
  Determines whether the database stores uppercase identifiers.
  `boolean`
  `storesUpperCaseQuotedIdentifiers()`
  Determines whether the database stores uppercase quoted SQL identifiers.
  `boolean`
  `supportsAlterTableWithAddColumn()`
  `boolean`
  `supportsAlterTableWithDropColumn()`
  `boolean`
  `supportsANSI92EntryLevelSQL()`
  `boolean`
  `supportsANSI92FullSQL()`
  `boolean`
  `supportsANSI92IntermediateSQL()`
  `boolean`
  `supportsBatchUpdates()`
  JDBC 2.0 Determines if the database supports batch updates.
  `boolean`
  `supportsCatalogsInDataManipulation()`
  Determines whether a data manipulation statement can contain a catalog name.
  `boolean`
  `supportsCatalogsInIndexDefinitions()`
  Determines whether an index definition statement can contain a catalog name.
  `boolean`
  `supportsCatalogsInPrivilegeDefinitions()`
  Determines whether a privilege definition statement can contain a catalog name.
  `boolean`
  `supportsCatalogsInProcedureCalls()`
  Determines whether a procedure call statement can contain a catalog name.
  `boolean`
  `supportsCatalogsInTableDefinitions()`
  Determines whether a table definition statement can contain a catalog name.
  `boolean`
  `supportsColumnAliasing()`
  `boolean`
  `supportsConvert()`
  `boolean`
  `supportsConvert(int fromType, int toType)`
  `boolean`
  `supportsCoreSQLGrammar()`
  `boolean`
  `supportsCorrelatedSubqueries()`
  Determines whether correlated subqueries are supported.
  `boolean`
  `supportsDataDefinitionAndDataManipulationTransactions()`
  Determines whether both data definition and data manipulation statements within a transaction are supported.
  `boolean`
  `supportsDataManipulationTransactionsOnly()`
  Determines whether data manipulation statements within a transaction are supported.
  `boolean`
  `supportsDifferentTableCorrelationNames()`
  `boolean`
  `supportsExpressionsInOrderBy()`
  `boolean`
  `supportsExtendedSQLGrammar()`
  `boolean`
  `supportsFullOuterJoins()`
  `boolean`
  `supportsGetGeneratedKeys()`
  `boolean`
  `supportsGroupBy()`
  `boolean`
  `supportsGroupByBeyondSelect()`
  `boolean`
  `supportsGroupByUnrelated()`
  `boolean`
  `supportsIntegrityEnhancementFacility()`
  `boolean`
  `supportsLikeEscapeClause()`
  `boolean`
  `supportsLimitedOuterJoins()`
  `boolean`
  `supportsMinimumSQLGrammar()`
  `boolean`
  `supportsMixedCaseIdentifiers()`
  Determines whether the database supports mixed-case, unquoted SQL identifiers.
  `boolean`
  `supportsMixedCaseQuotedIdentifiers()`
  Determines whether the database supports mixed-case quoted SQL identifiers.
  `boolean`
  `supportsMultipleOpenResults()`
  `boolean`
  `supportsMultipleResultSets()`
  `boolean`
  `supportsMultipleTransactions()`
  `boolean`
  `supportsNamedParameters()`
  `boolean`
  `supportsNonNullableColumns()`
  `boolean`
  `supportsOpenCursorsAcrossCommit()`
  Determines whether cursors can remain open across commits.
  `boolean`
  `supportsOpenCursorsAcrossRollback()`
  Determines whether cursors can remain open across rollback.
  `boolean`
  `supportsOpenStatementsAcrossCommit()`
  Determines whether statements can remain open across commits.
  `boolean`
  `supportsOpenStatementsAcrossRollback()`
  Determines whether statements can remain open across rollbacks.
  `boolean`
  `supportsOrderByUnrelated()`
  `boolean`
  `supportsOuterJoins()`
  `boolean`
  `supportsPositionedDelete()`
  Determines whether positioned DELETE is supported.
  `boolean`
  `supportsPositionedUpdate()`
  Determines whether positioned UPDATE is supported.
  `boolean`
  `supportsResultSetConcurrency(int type, int concurrency)`
  JDBC 2.0 Determines if the database supports the concurrency type in combination with the given result set type.
  `boolean`
  `supportsResultSetHoldability(int holdability)`
  `boolean`
  `supportsResultSetType(int type)`
  JDBC 2.0 Determines if the database supports the given result set type.
  `boolean`
  `supportsSavepoints()`
  `boolean`
  `supportsSchemasInDataManipulation()`
  Determines whether a data manipulation statement can contain a schema name.
  `boolean`
  `supportsSchemasInIndexDefinitions()`
  Determines whether an index definition statement can contain a schema name.
  `boolean`
  `supportsSchemasInPrivilegeDefinitions()`
  Determines whether a privilege definition statement can contain a schema name.
  `boolean`
  `supportsSchemasInProcedureCalls()`
  Determines whether a procedure call statement can contain a schema name.
  `boolean`
  `supportsSchemasInTableDefinitions()`
  Determines whether a table definition statement can contain a schema name.
  `boolean`
  `supportsSelectForUpdate()`
  Determines whether SELECT for UPDATE is supported.
  `boolean`
  `supportsStatementPooling()`
  `boolean`
  `supportsStoredFunctionsUsingCallSyntax()`
  `boolean`
  `supportsStoredProcedures()`
  Determines whether stored procedure calls that use the stored procedure escape syntax are supported.
  `boolean`
  `supportsSubqueriesInComparisons()`
  Determines whether subqueries in comparison expressions are supported.
  `boolean`
  `supportsSubqueriesInExists()`
  Determines whether subqueries in exists expressions are supported.
  `boolean`
  `supportsSubqueriesInIns()`
  Determines whether subqueries in "in" statements are supported.
  `boolean`
  `supportsSubqueriesInQuantifieds()`
  Determines whether subqueries in quantified expressions are supported.
  `boolean`
  `supportsTableCorrelationNames()`
  `boolean`
  `supportsTransactionIsolationLevel(int level)`
  Determines whether the database supports the transaction isolation level.
  `boolean`
  `supportsTransactions()`
  Determines whether transactions are supported.
  `boolean`
  `supportsUnion()`
  Determines whether an SQL UNION is supported.
  `boolean`
  `supportsUnionAll()`
  Determines whether an SQL UNION ALL is supported.
  `<T> T`
  `unwrap(Class<T> iface)`
  `boolean`
  `updatesAreDetected(int type)`
  JDBC 2.0 Determines whether or not a visible row update can be detected by calling ResultSet.rowUpdated().
  `boolean`
  `usesLocalFilePerTable()`
  Determines whether the database uses a file for each table.
  `boolean`
  `usesLocalFiles()`
  Determines whether the database stores each table in a local file.

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

  ### Methods inherited from interface java.sql.DatabaseMetaData

  `getMaxLogicalLobSize, supportsRefCursors, supportsSharding`

- ## Method Details

  - ### allProceduresAreCallable

    public boolean allProceduresAreCallable() throws SQLException
    Determines whether all stored procedures are callable.
    Specified by:
      `allProceduresAreCallable` in interface `DatabaseMetaData`
    Returns:
      False. SAS software does not support stored procedures.
    Throws:
      `SQLException` - This exception is required by the interface but it is never thrown.

  - ### allTablesAreSelectable

    public boolean allTablesAreSelectable() throws SQLException
    Determines whether all accessible tables are selectable.
    Specified by:
      `allTablesAreSelectable` in interface `DatabaseMetaData`
    Returns:
      True. All accessible tables are selectable.
    Throws:
      `SQLException` - This exception is required by the interface, but it is never thrown.

  - ### getURL

    public String getURL() throws SQLException
    Gets the URL from the MVAConnection object.
    Specified by:
      `getURL` in interface `DatabaseMetaData`
    Returns:
      The URL that is obtained from the MVAConnection object.
    Throws:
      `SQLException` - This exception is required by the interface, but it is never thrown.

  - ### getUserName

    public String getUserName() throws SQLException
    Gets the user name from the MVAConnection object.
    Specified by:
      `getUserName` in interface `DatabaseMetaData`
    Returns:
      The user name that is obtained from the MVAConnection object.
    Throws:
      `SQLException` - This exception is required by the interface, but it is never thrown.

  - ### isReadOnly

    public boolean isReadOnly() throws SQLException
    Determines whether the connection is read-only.
    Specified by:
      `isReadOnly` in interface `DatabaseMetaData`
    Returns:
      False. SAS software does not support read-only connections.
    Throws:
      `SQLException` - This exception is required by the interface, but it is never thrown.

  - ### nullsAreSortedHigh

    public boolean nullsAreSortedHigh() throws SQLException
    Determines whether NULLs are sorted high.
    Specified by:
      `nullsAreSortedHigh` in interface `DatabaseMetaData`
    Returns:
      False. NULLs are sorted low.
    Throws:
      `SQLException` - This exception is required by the interface, but it is never thrown.

  - ### nullsAreSortedLow

    public boolean nullsAreSortedLow() throws SQLException
    Determines whether NULLs are sorted low.
    Specified by:
      `nullsAreSortedLow` in interface `DatabaseMetaData`
    Returns:
      True. NULLs are sorted low.
    Throws:
      `SQLException` - This exception is required by the interface, but it is never thrown.

  - ### nullsAreSortedAtStart

    public boolean nullsAreSortedAtStart() throws SQLException
    Determines whether NULLs are sorted at start.
    Specified by:
      `nullsAreSortedAtStart` in interface `DatabaseMetaData`
    Returns:
      False. NULLs are sorted low
    Throws:
      `SQLException` - This exception is required by the interface, but it is never thrown.

  - ### nullsAreSortedAtEnd

    public boolean nullsAreSortedAtEnd() throws SQLException
    Determines whether NULLs are sorted at end.
    Specified by:
      `nullsAreSortedAtEnd` in interface `DatabaseMetaData`
    Returns:
      False. NULLs are sorted low
    Throws:
      `SQLException` - This exception is required by the interface, but it is never thrown.

  - ### getDatabaseProductName

    public String getDatabaseProductName() throws SQLException
    Gets the database product name.
    Specified by:
      `getDatabaseProductName` in interface `DatabaseMetaData`
    Returns:
      The string "SAS".
    Throws:
      `SQLException` - This exception is required by the interface, but it is never thrown.

  - ### getDatabaseProductVersion

    public String getDatabaseProductVersion() throws SQLException
    Returns the version of the MVA server.
    Specified by:
      `getDatabaseProductVersion` in interface `DatabaseMetaData`
    Returns:
      A string that contains the version number from the MVA server.
    Throws:
      `SQLException` - This exception is thrown if an error condition is detected or if the server does not respond.

  - ### getDriverName

    public String getDriverName() throws SQLException
    Retrieves the name of this JDBC driver.
    Specified by:
      `getDriverName` in interface `DatabaseMetaData`
    Returns:
      JDBC driver name
    Throws:
      `SQLException` - if a database access error occurs

  - ### getDriverVersion

    public String getDriverVersion() throws SQLException
    Retrieves the version number of this JDBC driver as a `String` .
    Specified by:
      `getDriverVersion` in interface `DatabaseMetaData`
    Returns:
      JDBC driver version
    Throws:
      `SQLException` - if a database access error occurs

  - ### getDriverMajorVersion

    public int getDriverMajorVersion()
    Retrieves this JDBC driver's major version number.
    Specified by:
      `getDriverMajorVersion` in interface `DatabaseMetaData`
    Returns:
      JDBC driver major version

  - ### getDriverMinorVersion

    public int getDriverMinorVersion()
    Retrieves this JDBC driver's minor version number.
    Specified by:
      `getDriverMinorVersion` in interface `DatabaseMetaData`
    Returns:
      JDBC driver minor version number

  - ### usesLocalFiles

    public boolean usesLocalFiles() throws SQLException
    Determines whether the database stores each table in a local file.
    Specified by:
      `usesLocalFiles` in interface `DatabaseMetaData`
    Returns:
      False.
    Throws:
      `SQLException` - This exception is required by the interface, but it is never thrown.

  - ### usesLocalFilePerTable

    public boolean usesLocalFilePerTable() throws SQLException
    Determines whether the database uses a file for each table.
    Specified by:
      `usesLocalFilePerTable` in interface `DatabaseMetaData`
    Returns:
      False.
    Throws:
      `SQLException` - This exception is required by the interface, but it is never thrown.

  - ### supportsMixedCaseIdentifiers

    public boolean supportsMixedCaseIdentifiers() throws SQLException
    Determines whether the database supports mixed-case, unquoted SQL identifiers.
    Specified by:
      `supportsMixedCaseIdentifiers` in interface `DatabaseMetaData`
    Returns:
      False.
    Throws:
      `SQLException` - This exception is required by the interface, but it is never thrown.

  - ### storesUpperCaseIdentifiers

    public boolean storesUpperCaseIdentifiers() throws SQLException
    Determines whether the database stores uppercase identifiers.
    Specified by:
      `storesUpperCaseIdentifiers` in interface `DatabaseMetaData`
    Returns:
      False.
    Throws:
      `SQLException` - This exception is required by the interface, but it is never thrown.

  - ### storesLowerCaseIdentifiers

    public boolean storesLowerCaseIdentifiers() throws SQLException
    Determines whether the database stores lowercase identifiers.
    Specified by:
      `storesLowerCaseIdentifiers` in interface `DatabaseMetaData`
    Returns:
      False.
    Throws:
      `SQLException` - This exception is required by the interface, but it is never thrown.

  - ### storesMixedCaseIdentifiers

    public boolean storesMixedCaseIdentifiers() throws SQLException
    Determines whether the database stores mixed-case identifiers.
    Specified by:
      `storesMixedCaseIdentifiers` in interface `DatabaseMetaData`
    Returns:
      True.
    Throws:
      `SQLException` - This exception is required by the interface, but it is never thrown.

  - ### supportsMixedCaseQuotedIdentifiers

    public boolean supportsMixedCaseQuotedIdentifiers() throws SQLException
    Determines whether the database supports mixed-case quoted SQL identifiers. This method is not JDBC compliant.
    Specified by:
      `supportsMixedCaseQuotedIdentifiers` in interface `DatabaseMetaData`
    Returns:
      false.
    Throws:
      `SQLException` - This exception is required by the interface, but it is never thrown.

  - ### storesUpperCaseQuotedIdentifiers

    public boolean storesUpperCaseQuotedIdentifiers() throws SQLException
    Determines whether the database stores uppercase quoted SQL identifiers.
    Specified by:
      `storesUpperCaseQuotedIdentifiers` in interface `DatabaseMetaData`
    Returns:
      False.
    Throws:
      `SQLException` - This exception is required by the interface, but it is never thrown.

  - ### storesLowerCaseQuotedIdentifiers

    public boolean storesLowerCaseQuotedIdentifiers() throws SQLException
    Determines whether the database stores lowercase quoted SQL identifiers.
    Specified by:
      `storesLowerCaseQuotedIdentifiers` in interface `DatabaseMetaData`
    Returns:
      False.
    Throws:
      `SQLException` - This exception is required by the interface, but it is never thrown.

  - ### storesMixedCaseQuotedIdentifiers

    public boolean storesMixedCaseQuotedIdentifiers() throws SQLException
    Determines whether the database stores mixed-case quoted SQL identifiers.
    Specified by:
      `storesMixedCaseQuotedIdentifiers` in interface `DatabaseMetaData`
    Returns:
      False.
    Throws:
      `SQLException` - This exception is required by the interface, but it is never thrown.

  - ### getIdentifierQuoteString

    public String getIdentifierQuoteString() throws SQLException
    Gets the quote string that is used to surround quoted SQL identifiers. SAS software does not support quoted identifiers, so a blank is returned. NOTE - SAS Software supports quoted ids, but only if the "dquote=ansi" option is set. The metadata will only consider what the default is, so no quoting possible. This method is not JDBC compliant.
    Specified by:
      `getIdentifierQuoteString` in interface `DatabaseMetaData`
    Returns:
      A blank string (" ").
    Throws:
      `SQLException` - This exception is required by the interface, but it is never thrown.

  - ### getSQLKeywords

    public String getSQLKeywords() throws SQLException
    Gets a comma-delimited list of all database-specific SQL keywords that are not SQL92 keywords.
    Specified by:
      `getSQLKeywords` in interface `DatabaseMetaData`
    Returns:
      An empty string (""). No additional keywords are reserved.
    Throws:
      `SQLException` - This exception is required by the interface, but it is never thrown.

  - ### getNumericFunctions

    public String getNumericFunctions() throws SQLException
    Specified by:
      `getNumericFunctions` in interface `DatabaseMetaData`
    Throws:
      `SQLException`

  - ### getStringFunctions

    public String getStringFunctions() throws SQLException
    Specified by:
      `getStringFunctions` in interface `DatabaseMetaData`
    Throws:
      `SQLException`

  - ### getSystemFunctions

    public String getSystemFunctions() throws SQLException
    Specified by:
      `getSystemFunctions` in interface `DatabaseMetaData`
    Throws:
      `SQLException`

  - ### getTimeDateFunctions

    public String getTimeDateFunctions() throws SQLException
    Specified by:
      `getTimeDateFunctions` in interface `DatabaseMetaData`
    Throws:
      `SQLException`

  - ### getSearchStringEscape

    public String getSearchStringEscape() throws SQLException
    Specified by:
      `getSearchStringEscape` in interface `DatabaseMetaData`
    Throws:
      `SQLException`

  - ### getExtraNameCharacters

    public String getExtraNameCharacters() throws SQLException
    Specified by:
      `getExtraNameCharacters` in interface `DatabaseMetaData`
    Throws:
      `SQLException`

  - ### supportsAlterTableWithAddColumn

    public boolean supportsAlterTableWithAddColumn() throws SQLException
    Specified by:
      `supportsAlterTableWithAddColumn` in interface `DatabaseMetaData`
    Throws:
      `SQLException`

  - ### supportsAlterTableWithDropColumn

    public boolean supportsAlterTableWithDropColumn() throws SQLException
    Specified by:
      `supportsAlterTableWithDropColumn` in interface `DatabaseMetaData`
    Throws:
      `SQLException`

  - ### supportsColumnAliasing

    public boolean supportsColumnAliasing() throws SQLException
    Specified by:
      `supportsColumnAliasing` in interface `DatabaseMetaData`
    Throws:
      `SQLException`

  - ### nullPlusNonNullIsNull

    public boolean nullPlusNonNullIsNull() throws SQLException
    Specified by:
      `nullPlusNonNullIsNull` in interface `DatabaseMetaData`
    Throws:
      `SQLException`

  - ### supportsConvert

    public boolean supportsConvert() throws SQLException
    Specified by:
      `supportsConvert` in interface `DatabaseMetaData`
    Throws:
      `SQLException`

  - ### supportsConvert

    public boolean supportsConvert(int fromType, int toType) throws SQLException
    Specified by:
      `supportsConvert` in interface `DatabaseMetaData`
    Throws:
      `SQLException`

  - ### supportsTableCorrelationNames

    public boolean supportsTableCorrelationNames() throws SQLException
    Specified by:
      `supportsTableCorrelationNames` in interface `DatabaseMetaData`
    Throws:
      `SQLException`

  - ### supportsDifferentTableCorrelationNames

    public boolean supportsDifferentTableCorrelationNames() throws SQLException
    Specified by:
      `supportsDifferentTableCorrelationNames` in interface `DatabaseMetaData`
    Throws:
      `SQLException`

  - ### supportsExpressionsInOrderBy

    public boolean supportsExpressionsInOrderBy() throws SQLException
    Specified by:
      `supportsExpressionsInOrderBy` in interface `DatabaseMetaData`
    Throws:
      `SQLException`

  - ### supportsOrderByUnrelated

    public boolean supportsOrderByUnrelated() throws SQLException
    Specified by:
      `supportsOrderByUnrelated` in interface `DatabaseMetaData`
    Throws:
      `SQLException`

  - ### supportsGroupBy

    public boolean supportsGroupBy() throws SQLException
    Specified by:
      `supportsGroupBy` in interface `DatabaseMetaData`
    Throws:
      `SQLException`

  - ### supportsGroupByUnrelated

    public boolean supportsGroupByUnrelated() throws SQLException
    Specified by:
      `supportsGroupByUnrelated` in interface `DatabaseMetaData`
    Throws:
      `SQLException`

  - ### supportsGroupByBeyondSelect

    public boolean supportsGroupByBeyondSelect() throws SQLException
    Specified by:
      `supportsGroupByBeyondSelect` in interface `DatabaseMetaData`
    Throws:
      `SQLException`

  - ### supportsLikeEscapeClause

    public boolean supportsLikeEscapeClause() throws SQLException
    Specified by:
      `supportsLikeEscapeClause` in interface `DatabaseMetaData`
    Throws:
      `SQLException`

  - ### supportsMultipleResultSets

    public boolean supportsMultipleResultSets() throws SQLException
    Specified by:
      `supportsMultipleResultSets` in interface `DatabaseMetaData`
    Throws:
      `SQLException`

  - ### supportsMultipleTransactions

    public boolean supportsMultipleTransactions() throws SQLException
    Specified by:
      `supportsMultipleTransactions` in interface `DatabaseMetaData`
    Throws:
      `SQLException`

  - ### supportsNonNullableColumns

    public boolean supportsNonNullableColumns() throws SQLException
    Specified by:
      `supportsNonNullableColumns` in interface `DatabaseMetaData`
    Throws:
      `SQLException`

  - ### supportsMinimumSQLGrammar

    public boolean supportsMinimumSQLGrammar() throws SQLException
    Specified by:
      `supportsMinimumSQLGrammar` in interface `DatabaseMetaData`
    Throws:
      `SQLException`

  - ### supportsCoreSQLGrammar

    public boolean supportsCoreSQLGrammar() throws SQLException
    Specified by:
      `supportsCoreSQLGrammar` in interface `DatabaseMetaData`
    Throws:
      `SQLException`

  - ### supportsExtendedSQLGrammar

    public boolean supportsExtendedSQLGrammar() throws SQLException
    Specified by:
      `supportsExtendedSQLGrammar` in interface `DatabaseMetaData`
    Throws:
      `SQLException`

  - ### supportsANSI92EntryLevelSQL

    public boolean supportsANSI92EntryLevelSQL() throws SQLException
    Specified by:
      `supportsANSI92EntryLevelSQL` in interface `DatabaseMetaData`
    Throws:
      `SQLException`

  - ### supportsANSI92IntermediateSQL

    public boolean supportsANSI92IntermediateSQL() throws SQLException
    Specified by:
      `supportsANSI92IntermediateSQL` in interface `DatabaseMetaData`
    Throws:
      `SQLException`

  - ### supportsANSI92FullSQL

    public boolean supportsANSI92FullSQL() throws SQLException
    Specified by:
      `supportsANSI92FullSQL` in interface `DatabaseMetaData`
    Throws:
      `SQLException`

  - ### supportsIntegrityEnhancementFacility

    public boolean supportsIntegrityEnhancementFacility() throws SQLException
    Specified by:
      `supportsIntegrityEnhancementFacility` in interface `DatabaseMetaData`
    Throws:
      `SQLException`

  - ### supportsOuterJoins

    public boolean supportsOuterJoins() throws SQLException
    Specified by:
      `supportsOuterJoins` in interface `DatabaseMetaData`
    Throws:
      `SQLException`

  - ### supportsFullOuterJoins

    public boolean supportsFullOuterJoins() throws SQLException
    Specified by:
      `supportsFullOuterJoins` in interface `DatabaseMetaData`
    Throws:
      `SQLException`

  - ### supportsLimitedOuterJoins

    public boolean supportsLimitedOuterJoins() throws SQLException
    Specified by:
      `supportsLimitedOuterJoins` in interface `DatabaseMetaData`
    Throws:
      `SQLException`

  - ### getSchemaTerm

    public String getSchemaTerm() throws SQLException
    Retrieves the database vendor's preferred term for "schema". For SAS, this is "library".
    Specified by:
      `getSchemaTerm` in interface `DatabaseMetaData`
    Returns:
      the vendor term for "schema"
    Throws:
      `SQLException` - if a database access error occurs

  - ### getProcedureTerm

    public String getProcedureTerm() throws SQLException
    Gets the preferred term for "procedure".
    Specified by:
      `getProcedureTerm` in interface `DatabaseMetaData`
    Returns:
      An empty string ("").
    Throws:
      `SQLException` - This exception is required by the interface, but it is never thrown.

  - ### getCatalogTerm

    public String getCatalogTerm() throws SQLException
    Gets the preferred term for "catalog".
    Specified by:
      `getCatalogTerm` in interface `DatabaseMetaData`
    Returns:
      An empty string ("").
    Throws:
      `SQLException` - This exception is required by the interface, but it is never thrown.

  - ### isCatalogAtStart

    public boolean isCatalogAtStart() throws SQLException
    Determines whether a catalog appears at the start of a qualified table name.
    Specified by:
      `isCatalogAtStart` in interface `DatabaseMetaData`
    Returns:
      False.
    Throws:
      `SQLException` - This exception is required by the interface, but it is never thrown.

  - ### getCatalogSeparator

    public String getCatalogSeparator() throws SQLException
    Gets the separator that is being used between the catalog name and the table name.
    Specified by:
      `getCatalogSeparator` in interface `DatabaseMetaData`
    Returns:
      An empty string ("").
    Throws:
      `SQLException` - This exception is required by the interface, but it is never thrown.

  - ### supportsSchemasInDataManipulation

    public boolean supportsSchemasInDataManipulation() throws SQLException
    Determines whether a data manipulation statement can contain a schema name.
    Specified by:
      `supportsSchemasInDataManipulation` in interface `DatabaseMetaData`
    Returns:
      True.
    Throws:
      `SQLException` - This exception is required by the interface, but it is never thrown.

  - ### supportsSchemasInProcedureCalls

    public boolean supportsSchemasInProcedureCalls() throws SQLException
    Determines whether a procedure call statement can contain a schema name.
    Specified by:
      `supportsSchemasInProcedureCalls` in interface `DatabaseMetaData`
    Returns:
      False. SAS software does not support stored procedures.
    Throws:
      `SQLException` - This exception is required by the interface, but it is never thrown.

  - ### supportsSchemasInTableDefinitions

    public boolean supportsSchemasInTableDefinitions() throws SQLException
    Determines whether a table definition statement can contain a schema name.
    Specified by:
      `supportsSchemasInTableDefinitions` in interface `DatabaseMetaData`
    Returns:
      True.
    Throws:
      `SQLException` - This exception is required by the interface, but it is never thrown.

  - ### supportsSchemasInIndexDefinitions

    public boolean supportsSchemasInIndexDefinitions() throws SQLException
    Determines whether an index definition statement can contain a schema name.
    Specified by:
      `supportsSchemasInIndexDefinitions` in interface `DatabaseMetaData`
    Returns:
      True.
    Throws:
      `SQLException` - This exception is required by the interface, but it is never thrown.

  - ### supportsSchemasInPrivilegeDefinitions

    public boolean supportsSchemasInPrivilegeDefinitions() throws SQLException
    Determines whether a privilege definition statement can contain a schema name.
    Specified by:
      `supportsSchemasInPrivilegeDefinitions` in interface `DatabaseMetaData`
    Returns:
      False. SAS software does not support privileges.
    Throws:
      `SQLException` - This exception is required by the interface, but it is never thrown.

  - ### supportsCatalogsInDataManipulation

    public boolean supportsCatalogsInDataManipulation() throws SQLException
    Determines whether a data manipulation statement can contain a catalog name.
    Specified by:
      `supportsCatalogsInDataManipulation` in interface `DatabaseMetaData`
    Returns:
      False. SAS software does not support SQL catalogs.
    Throws:
      `SQLException` - This exception is required by the interface, but it is never thrown.

  - ### supportsCatalogsInProcedureCalls

    public boolean supportsCatalogsInProcedureCalls() throws SQLException
    Determines whether a procedure call statement can contain a catalog name.
    Specified by:
      `supportsCatalogsInProcedureCalls` in interface `DatabaseMetaData`
    Returns:
      False. SAS software does not support SQL catalogs.
    Throws:
      `SQLException` - This exception is required by the interface, but it is never thrown.

  - ### supportsCatalogsInTableDefinitions

    public boolean supportsCatalogsInTableDefinitions() throws SQLException
    Determines whether a table definition statement can contain a catalog name.
    Specified by:
      `supportsCatalogsInTableDefinitions` in interface `DatabaseMetaData`
    Returns:
      False. SAS software does not support SQL catalogs.
    Throws:
      `SQLException` - This exception is required by the interface, but it is never thrown.

  - ### supportsCatalogsInIndexDefinitions

    public boolean supportsCatalogsInIndexDefinitions() throws SQLException
    Determines whether an index definition statement can contain a catalog name.
    Specified by:
      `supportsCatalogsInIndexDefinitions` in interface `DatabaseMetaData`
    Returns:
      False. SAS software does not support SQL catalogs.
    Throws:
      `SQLException` - This exception is required by the interface, but it is never thrown.

  - ### supportsCatalogsInPrivilegeDefinitions

    public boolean supportsCatalogsInPrivilegeDefinitions() throws SQLException
    Determines whether a privilege definition statement can contain a catalog name.
    Specified by:
      `supportsCatalogsInPrivilegeDefinitions` in interface `DatabaseMetaData`
    Returns:
      False. SAS software does not support SQL catalogs.
    Throws:
      `SQLException` - This exception is required by the interface, but it is never thrown.

  - ### supportsPositionedDelete

    public boolean supportsPositionedDelete() throws SQLException
    Determines whether positioned DELETE is supported.
    Specified by:
      `supportsPositionedDelete` in interface `DatabaseMetaData`
    Returns:
      False.
    Throws:
      `SQLException` - This exception is required by the interface, but it is never thrown.

  - ### supportsPositionedUpdate

    public boolean supportsPositionedUpdate() throws SQLException
    Determines whether positioned UPDATE is supported.
    Specified by:
      `supportsPositionedUpdate` in interface `DatabaseMetaData`
    Returns:
      False.
    Throws:
      `SQLException` - This exception is required by the interface, but it is never thrown.

  - ### supportsSelectForUpdate

    public boolean supportsSelectForUpdate() throws SQLException
    Determines whether SELECT for UPDATE is supported.
    Specified by:
      `supportsSelectForUpdate` in interface `DatabaseMetaData`
    Returns:
      False.
    Throws:
      `SQLException` - This exception is required by the interface, but it is never thrown.

  - ### supportsStoredProcedures

    public boolean supportsStoredProcedures() throws SQLException
    Determines whether stored procedure calls that use the stored procedure escape syntax are supported.
    Specified by:
      `supportsStoredProcedures` in interface `DatabaseMetaData`
    Returns:
      False.
    Throws:
      `SQLException` - This exception is required by the interface, but it is never thrown.

  - ### supportsSubqueriesInComparisons

    public boolean supportsSubqueriesInComparisons() throws SQLException
    Determines whether subqueries in comparison expressions are supported.
    Specified by:
      `supportsSubqueriesInComparisons` in interface `DatabaseMetaData`
    Returns:
      True.
    Throws:
      `SQLException` - This exception is required by the interface, but it is never thrown.

  - ### supportsSubqueriesInExists

    public boolean supportsSubqueriesInExists() throws SQLException
    Determines whether subqueries in exists expressions are supported.
    Specified by:
      `supportsSubqueriesInExists` in interface `DatabaseMetaData`
    Returns:
      True.
    Throws:
      `SQLException` - This exception is required by the interface, but it is never thrown.

  - ### supportsSubqueriesInIns

    public boolean supportsSubqueriesInIns() throws SQLException
    Determines whether subqueries in "in" statements are supported.
    Specified by:
      `supportsSubqueriesInIns` in interface `DatabaseMetaData`
    Returns:
      True.
    Throws:
      `SQLException` - This exception is required by the interface, but it is never thrown.

  - ### supportsSubqueriesInQuantifieds

    public boolean supportsSubqueriesInQuantifieds() throws SQLException
    Determines whether subqueries in quantified expressions are supported.
    Specified by:
      `supportsSubqueriesInQuantifieds` in interface `DatabaseMetaData`
    Returns:
      True.
    Throws:
      `SQLException` - This exception is required by the interface, but it is never thrown.

  - ### supportsCorrelatedSubqueries

    public boolean supportsCorrelatedSubqueries() throws SQLException
    Determines whether correlated subqueries are supported.
    Specified by:
      `supportsCorrelatedSubqueries` in interface `DatabaseMetaData`
    Returns:
      True.
    Throws:
      `SQLException` - This exception is required by the interface, but it is never thrown.

  - ### supportsUnion

    public boolean supportsUnion() throws SQLException
    Determines whether an SQL UNION is supported.
    Specified by:
      `supportsUnion` in interface `DatabaseMetaData`
    Returns:
      True.
    Throws:
      `SQLException` - This exception is required by the interface, but it is never thrown.

  - ### supportsUnionAll

    public boolean supportsUnionAll() throws SQLException
    Determines whether an SQL UNION ALL is supported.
    Specified by:
      `supportsUnionAll` in interface `DatabaseMetaData`
    Returns:
      True.
    Throws:
      `SQLException` - This exception is required by the interface, but it is never thrown.

  - ### supportsOpenCursorsAcrossCommit

    public boolean supportsOpenCursorsAcrossCommit() throws SQLException
    Determines whether cursors can remain open across commits.
    Specified by:
      `supportsOpenCursorsAcrossCommit` in interface `DatabaseMetaData`
    Returns:
      False. SAS software does not support transactions.
    Throws:
      `SQLException` - This exception is required by the interface, but it is never thrown.

  - ### supportsOpenCursorsAcrossRollback

    public boolean supportsOpenCursorsAcrossRollback() throws SQLException
    Determines whether cursors can remain open across rollback.
    Specified by:
      `supportsOpenCursorsAcrossRollback` in interface `DatabaseMetaData`
    Returns:
      False. SAS software does not support transactions.
    Throws:
      `SQLException` - This exception is required by the interface, but it is never thrown.

  - ### supportsOpenStatementsAcrossCommit

    public boolean supportsOpenStatementsAcrossCommit() throws SQLException
    Determines whether statements can remain open across commits.
    Specified by:
      `supportsOpenStatementsAcrossCommit` in interface `DatabaseMetaData`
    Returns:
      True.
    Throws:
      `SQLException` - This exception is required by the interface, but it is never thrown.

  - ### supportsOpenStatementsAcrossRollback

    public boolean supportsOpenStatementsAcrossRollback() throws SQLException
    Determines whether statements can remain open across rollbacks.
    Specified by:
      `supportsOpenStatementsAcrossRollback` in interface `DatabaseMetaData`
    Returns:
      True. SAS software does not support transactions.
    Throws:
      `SQLException` - This exception is required by the interface, but it is never thrown.

  - ### getMaxBinaryLiteralLength

    public int getMaxBinaryLiteralLength() throws SQLException
    Returns the number of hex characters that are allowed in an inline binary literal.
    Specified by:
      `getMaxBinaryLiteralLength` in interface `DatabaseMetaData`
    Returns:
      0. There is no limit.
    Throws:
      `SQLException` - This exception is required by the interface, but it is never thrown.

  - ### getMaxCharLiteralLength

    public int getMaxCharLiteralLength() throws SQLException
    Returns the maximum length of a character literal.
    Specified by:
      `getMaxCharLiteralLength` in interface `DatabaseMetaData`
    Returns:
      32767.
    Throws:
      `SQLException` - This exception is required by the interface, but it is never thrown.

  - ### getMaxColumnNameLength

    public int getMaxColumnNameLength() throws SQLException
    Returns the maximum length of a column name.
    Specified by:
      `getMaxColumnNameLength` in interface `DatabaseMetaData`
    Returns:
      32.
    Throws:
      `SQLException` - This exception is required by the interface, but it is never thrown.

  - ### getMaxColumnsInGroupBy

    public int getMaxColumnsInGroupBy() throws SQLException
    Indicates the maximum number of columns that are allowed in a GROUP BY clause.
    Specified by:
      `getMaxColumnsInGroupBy` in interface `DatabaseMetaData`
    Returns:
      0. There is no limit.
    Throws:
      `SQLException` - This exception is required by the interface, but it is never thrown.

  - ### getMaxColumnsInIndex

    public int getMaxColumnsInIndex() throws SQLException
    Indicates the maximum number of columns that are allowed in an index.
    Specified by:
      `getMaxColumnsInIndex` in interface `DatabaseMetaData`
    Returns:
      0. There is no limit.
    Throws:
      `SQLException` - This exception is required by the interface, but it is never thrown.

  - ### getMaxColumnsInOrderBy

    public int getMaxColumnsInOrderBy() throws SQLException
    Indicates the maximum number of columns that are allowed in an ORDER BY clause.
    Specified by:
      `getMaxColumnsInOrderBy` in interface `DatabaseMetaData`
    Returns:
      0. There is no limit.
    Throws:
      `SQLException` - This exception is required by the interface, but it is never thrown.

  - ### getMaxColumnsInSelect

    public int getMaxColumnsInSelect() throws SQLException
    Determines the maximum number of columns that are allowed in a SELECT list.
    Specified by:
      `getMaxColumnsInSelect` in interface `DatabaseMetaData`
    Returns:
      0. There is no limit.
    Throws:
      `SQLException` - This exception is required by the interface, but it is never thrown.

  - ### getMaxColumnsInTable

    public int getMaxColumnsInTable() throws SQLException
    Indicates the maximum number of columns that are allowed in a table.
    Specified by:
      `getMaxColumnsInTable` in interface `DatabaseMetaData`
    Returns:
      0. There is no limit.
    Throws:
      `SQLException` - This exception is required by the interface, but it is never thrown.

  - ### getMaxConnections

    public int getMaxConnections() throws SQLException
    Indicates the maximum number of database connections that can be active concurrently.
    Specified by:
      `getMaxConnections` in interface `DatabaseMetaData`
    Returns:
      0. There is no limit.
    Throws:
      `SQLException` - This exception is required by the interface, but it is never thrown.

  - ### getMaxCursorNameLength

    public int getMaxCursorNameLength() throws SQLException
    Indicates the maximum length of a cursor name.
    Specified by:
      `getMaxCursorNameLength` in interface `DatabaseMetaData`
    Returns:
      0. SAS software does not support cursors.
    Throws:
      `SQLException` - This exception is required by the interface, but it is never thrown.

  - ### getMaxIndexLength

    public int getMaxIndexLength() throws SQLException
    Indicates the maximum size of an index (in bytes).
    Specified by:
      `getMaxIndexLength` in interface `DatabaseMetaData`
    Returns:
      0. There is no limit.
    Throws:
      `SQLException` - This exception is required by the interface, but it is never thrown.

  - ### getMaxSchemaNameLength

    public int getMaxSchemaNameLength() throws SQLException
    Indicates the maximum length of a schema name.
    Specified by:
      `getMaxSchemaNameLength` in interface `DatabaseMetaData`
    Returns:
      8.
    Throws:
      `SQLException` - This exception is required by the interface, but it is never thrown.

  - ### getMaxProcedureNameLength

    public int getMaxProcedureNameLength() throws SQLException
    Indicates the maximum length of a procedure name.
    Specified by:
      `getMaxProcedureNameLength` in interface `DatabaseMetaData`
    Returns:
      0. SAS software does not support stored procedures.
    Throws:
      `SQLException` - This exception is required by the interface, but it is never thrown.

  - ### getMaxCatalogNameLength

    public int getMaxCatalogNameLength() throws SQLException
    Indicates the maximum length of a catalog name.
    Specified by:
      `getMaxCatalogNameLength` in interface `DatabaseMetaData`
    Returns:
      0. SAS software does not support SQL catalogs.
    Throws:
      `SQLException` - This exception is required by the interface, but it is never thrown.

  - ### getMaxRowSize

    public int getMaxRowSize() throws SQLException
    Indicates the maximum length of a single row.
    Specified by:
      `getMaxRowSize` in interface `DatabaseMetaData`
    Returns:
      0. There is no limit.
    Throws:
      `SQLException` - This exception is required by the interface, but it is never thrown.

  - ### doesMaxRowSizeIncludeBlobs

    public boolean doesMaxRowSizeIncludeBlobs() throws SQLException
    Determines whether getMaxRowSize() includes LONGVARCHAR and LONGVARBINARY blobs.
    Specified by:
      `doesMaxRowSizeIncludeBlobs` in interface `DatabaseMetaData`
    Returns:
      True.
    Throws:
      `SQLException` - This exception is required by the interface, but it is never thrown.

  - ### getMaxStatementLength

    public int getMaxStatementLength() throws SQLException
    Indicates the maximum length of an SQL statement.
    Specified by:
      `getMaxStatementLength` in interface `DatabaseMetaData`
    Returns:
      0. There is no limit.
    Throws:
      `SQLException` - This exception is required by the interface, but it is never thrown.

  - ### getMaxStatements

    public int getMaxStatements() throws SQLException
    Indicates the maximum number of active statements that can be open to this database concurrently.
    Specified by:
      `getMaxStatements` in interface `DatabaseMetaData`
    Returns:
      0. There is no limit.
    Throws:
      `SQLException` - This exception is required by the interface, but it is never thrown.

  - ### getMaxTableNameLength

    public int getMaxTableNameLength() throws SQLException
    Indicates the maximum length of a table name.
    Specified by:
      `getMaxTableNameLength` in interface `DatabaseMetaData`
    Returns:
      32.
    Throws:
      `SQLException` - This exception is required by the interface, but it is never thrown.

  - ### getMaxTablesInSelect

    public int getMaxTablesInSelect() throws SQLException
    Indicates the maximum number of tables in a SELECT list.
    Specified by:
      `getMaxTablesInSelect` in interface `DatabaseMetaData`
    Returns:
      0. There is no limit.
    Throws:
      `SQLException` - This exception is required by the interface, but it is never thrown.

  - ### getMaxUserNameLength

    public int getMaxUserNameLength() throws SQLException
    Indicates the maximum length of a user name.
    Specified by:
      `getMaxUserNameLength` in interface `DatabaseMetaData`
    Returns:
      8.
    Throws:
      `SQLException` - This exception is required by the interface, but it is never thrown.

  - ### getDefaultTransactionIsolation

    public int getDefaultTransactionIsolation() throws SQLException
    Gets the default transaction isolation level for the database.
    Specified by:
      `getDefaultTransactionIsolation` in interface `DatabaseMetaData`
    Returns:
      java.sql.Connection.TRANSACTION_NONE
    Throws:
      `SQLException` - This exception is required by the interface, but it is never thrown.

  - ### supportsTransactions

    public boolean supportsTransactions() throws SQLException
    Determines whether transactions are supported.
    Specified by:
      `supportsTransactions` in interface `DatabaseMetaData`
    Returns:
      False.
    Throws:
      `SQLException` - This exception is required by the interface, but it is never thrown.

  - ### supportsTransactionIsolationLevel

    public boolean supportsTransactionIsolationLevel(int level) throws SQLException
    Determines whether the database supports the transaction isolation level.
    Specified by:
      `supportsTransactionIsolationLevel` in interface `DatabaseMetaData`
    Returns:
      True if the transaction isolation level is set to java.sql.Connection.TRANSACTION_NONE, else False.
    Throws:
      `SQLException` - This exception is required by the interface, but it is never thrown.

  - ### supportsDataDefinitionAndDataManipulationTransactions

    public boolean supportsDataDefinitionAndDataManipulationTransactions() throws SQLException
    Determines whether both data definition and data manipulation statements within a transaction are supported.
    Specified by:
      `supportsDataDefinitionAndDataManipulationTransactions` in interface `DatabaseMetaData`
    Returns:
      False. SAS software does not support transactions.
    Throws:
      `SQLException` - This exception is required by the interface, but it is never thrown.

  - ### supportsDataManipulationTransactionsOnly

    public boolean supportsDataManipulationTransactionsOnly() throws SQLException
    Determines whether data manipulation statements within a transaction are supported.
    Specified by:
      `supportsDataManipulationTransactionsOnly` in interface `DatabaseMetaData`
    Returns:
      False. SAS software does not support transactions.
    Throws:
      `SQLException` - This exception is required by the interface, but it is never thrown.

  - ### dataDefinitionCausesTransactionCommit

    public boolean dataDefinitionCausesTransactionCommit() throws SQLException
    Determines whether a data definition statement within a transaction forces the transaction to commit.
    Specified by:
      `dataDefinitionCausesTransactionCommit` in interface `DatabaseMetaData`
    Returns:
      False. SAS software does not support transactions.
    Throws:
      `SQLException` - This exception is required by the interface, but it is never thrown.

  - ### dataDefinitionIgnoredInTransactions

    public boolean dataDefinitionIgnoredInTransactions() throws SQLException
    Determines whether a data definition statement within a transaction is ignored.
    Specified by:
      `dataDefinitionIgnoredInTransactions` in interface `DatabaseMetaData`
    Returns:
      False. SAS software does not support transactions.
    Throws:
      `SQLException` - This exception is required by the interface, but it is never thrown.

  - ### getProcedures

    public ResultSet getProcedures(String catalog, String schemaPattern, String procedureNamePattern) throws SQLException
    Get a description of stored procedures available in a catalog. This method is not supported.
    Specified by:
      `getProcedures` in interface `DatabaseMetaData`
    Throws:
      `SQLException` - This exception is always thrown.

  - ### getProcedureColumns

    public ResultSet getProcedureColumns(String catalog, String schemaPattern, String procedureNamePattern, String columnNamePattern) throws SQLException
    Gets a description of a catalog's stored procedure parameters and result columns. This method is not supported.
    Specified by:
      `getProcedureColumns` in interface `DatabaseMetaData`
    Throws:
      `SQLException` - This exception is always thrown.

  - ### getTables

    public ResultSet getTables(String catalog, String schemaPattern, String tableNamePattern, String[] types) throws SQLException
    Gets a description of the tables that are available in a catalog.

    Only table descriptions that match the catalog, schema, table name, and type criteria are returned. The rows are ordered by TABLE_TYPE, TABLE_SCHEM and TABLE_NAME.

    Each table description contains the following columns:

    Column name | Data type | Description
    --- | --- | ---
    CATALOG | String | The table catalog (can be NULL)
    SCHEMA | String | The table schema (can be NULL)
    TABLE | String | The table name
    TYPE | String | The table type
    COMMENT | String | An explanatory comment regarding the table
    table_pass | String | A non-standard column returning the password protection of the table. The returned column values would be one of NULL, READ, WRITE, ALTER values. A NULL is returned if no passwords are defined for the table. Since this is a non-standard result, this column must be referenced by name.

    Specified by:
      `getTables` in interface `DatabaseMetaData`
    Parameters:
      `catalog` - A catalog name. An empty string ("") retrieves the rows that do not have a catalog.
      `schemaPattern` - A schema name pattern. An empty string ("") retrieves the rows that do not have a schema.
      `tableNamePattern` - A table name pattern.
      `types` - A list of table types to include. A value of NULL returns all types.
    Returns:
      ResultSet in which each row is a table description.
    Throws:
      `SQLException` - This exception is thrown if there is no connection to server or if an IO exception is detected.

  - ### getSchemas

    public ResultSet getSchemas() throws SQLException
    Retrieves the schema names available in this database. The results are ordered by schema name. A SAS schema is a LIBREF.

    The schema column is:

    1. TABLE_SCHEM String => schema name
    Specified by:
      `getSchemas` in interface `DatabaseMetaData`
    Returns:
      a `ResultSet` object in which each row is a schema description
    Throws:
      `SQLException` - if a database access error occurs

  - ### getCatalogs

    public ResultSet getCatalogs() throws SQLException
    Retrieves the catalog names available in this database. The results are ordered by catalog name. SAS does not support catalogs, so the returned result set will always be empty.

    The catalog column is:

    1. TABLE_CAT String => catalog name
    Specified by:
      `getCatalogs` in interface `DatabaseMetaData`
    Returns:
      an empty `ResultSet` object. A single column `String` column that is a catalog name.
    Throws:
      `SQLException` - if a database access error occurs

  - ### getTableTypes

    public ResultSet getTableTypes() throws SQLException
    The `MVADatabaseMetaData` implementation of `DatabaseMetadata#getTables(String, String, String, String[])` always returns a result set containing "TABLE" and "VIEW". These are the only table types supported by SAS libraries.

    Specified by:
      `getTableTypes` in interface `DatabaseMetaData`
    Throws:
      `SQLException`

  - ### getColumns

    public ResultSet getColumns(String catalog, String schemaPattern, String tableNamePattern, String columnNamePattern) throws SQLException
    Gets a description of table columns available in a catalog.

    Only column descriptions matching the catalog, schema, table and column name criteria are returned. The descriptions are ordered by TABLE_SCHEM, TABLE_NAME and ORDINAL_POSITION.

    Each column description contains the following columns:

    Column name | Data type | Description
    --- | --- | ---
    CATALOG | String | A table catalog (can be NULL)
    SCHEMA | String | A table schema (can be NULL)
    TABLE | String | A table name
    NAME | String | A column name
    SQLTYPE | short | An SQL type from java.sql.Types
    TYPE | String | A data-source-dependent format name including format width and decimal
    SIZE | int | The column size (For char or date types, this is the maximum number of characters; for numeric or decimal types, this is precision.)
    EMPTY | NULL | Not used
    SCALE | int | The number of fractional digits
    RADIX | int | The radix (typically either 10 or 2)
    NULLABLE | int | Constants that state whether NULL is allowed: columnNoNulls - NULL values can possibly not be allowed columnNullable - NULL values are allowed columnNullableUnknown - Nullability is unknown
    COMMENT | String | A comment describing the column (can be NULL)
    DEFAULT | String | The default value (can be NULL)
    EMPTY2 | int | Not used
    EMPTY3 | int | Not used
    MAX | int | For char types, this is the maximum number of bytes in the column
    POSITION | int | The index of the column in the table (starting at 1)
    NOTKNOWN | String | Strings that state whether NULL is allowed: "NO" means that the column definitely does not allow NULL values "YES" means that the column might allow NULL values An empty string ("") means unknown

    Specified by:
      `getColumns` in interface `DatabaseMetaData`
    Parameters:
      `catalog` - A catalog name. An empty string ("") retrieves the rows that do not have a catalog.
      `schemaPattern` - A schema name pattern. An empty string ("") retrieves the rows that do not have a schema.
      `tableNamePattern` - A table name pattern. For password protected tables the parameter will be of the form myTable(pw=XXXX).
      `columnNamePattern` - A column name pattern.
    Throws:
      `SQLException` - This exception may be thrown.

  - ### getColumnPrivileges

    public ResultSet getColumnPrivileges(String catalog, String schema, String table, String columnNamePattern) throws SQLException
    Gets a description of the access rights for a table's columns. This method is not supported.
    Specified by:
      `getColumnPrivileges` in interface `DatabaseMetaData`
    Throws:
      `SQLException` - This exception is always thrown.

  - ### getTablePrivileges

    public ResultSet getTablePrivileges(String catalog, String schemaPattern, String tableNamePattern) throws SQLException
    Gets a description of the access rights each table available in a catalog. This method is not supported.
    Specified by:
      `getTablePrivileges` in interface `DatabaseMetaData`
    Throws:
      `SQLException` - This exception is always thrown.

  - ### getBestRowIdentifier

    public ResultSet getBestRowIdentifier(String catalog, String schema, String table, int scope, boolean nullable) throws SQLException
    Retrieves a description of a table's optimal set of columns that uniquely identifies a row. They are ordered by SCOPE.

    Each column description has the following columns:

    1. SCOPE short => actual scope of result
       - bestRowTemporary - very temporary, while using row
       - bestRowTransaction - valid for remainder of current transaction
       - bestRowSession - valid for remainder of current session
    2. COLUMN_NAME String => column name
    3. DATA_TYPE int => SQL data type from java.sql.Types
    4. TYPE_NAME String => Data source dependent type name, for a UDT the type name is fully qualified
    5. COLUMN_SIZE int => precision
    6. BUFFER_LENGTH int => not used
    7. DECIMAL_DIGITS short => scale
    8. PSEUDO_COLUMN short => is this a pseudo column like an Oracle ROWID
       - bestRowUnknown - may or may not be pseudo column
       - bestRowNotPseudo - is NOT a pseudo column
       - bestRowPseudo - is a pseudo column
    9. format String => SAS format. Non standard column. Must be retrieved with column name, not column position.
    Specified by:
      `getBestRowIdentifier` in interface `DatabaseMetaData`
    Parameters:
      `catalog` - a catalog name; must match the catalog name as it is stored in the database; "" retrieves those without a catalog; `null` means that the catalog name should not be used to narrow the search
      `schema` - a schema name; must match the schema name as it is stored in the database; "" retrieves those without a schema; `null` means that the schema name should not be used to narrow the search
      `table` - a table name; must match the table name as it is stored in the database
      `scope` - the scope of interest; use same values as SCOPE
      `nullable` - include columns that are nullable.
    Returns:
      `ResultSet` - each row is a column description
    Throws:
      `SQLException` - if a database access error occurs

  - ### getVersionColumns

    public ResultSet getVersionColumns(String catalog, String schema, String table) throws SQLException
    Gets a description of the table columns that are automatically updated when any value in a row is updated. This method is not supported.
    Specified by:
      `getVersionColumns` in interface `DatabaseMetaData`
    Returns:
      An exception is always thrown. No columns are automatically updated.
    Throws:
      `SQLException` - This exception is always thrown.

  - ### getPrimaryKeys

    public ResultSet getPrimaryKeys(String catalog, String schema, String table) throws SQLException
    Retrieves a description of the given table's primary key columns. They are ordered by COLUMN_NAME.

    Each primary key column description has the following columns:

    1. TABLE_CAT String => table catalog (may be `null`)
    2. TABLE_SCHEM String => table schema (may be `null`)
    3. TABLE_NAME String => table name
    4. COLUMN_NAME String => column name
    5. KEY_SEQ short => sequence number within primary key
    6. PK_NAME String => primary key name (may be `null`)
    Specified by:
      `getPrimaryKeys` in interface `DatabaseMetaData`
    Parameters:
      `catalog` - a catalog name; must match the catalog name as it is stored in the database; "" retrieves those without a catalog; `null` means that the catalog name should not be used to narrow the search
      `schema` - a schema name; must match the schema name as it is stored in the database; "" retrieves those without a schema; `null` means that the schema name should not be used to narrow the search
      `table` - a table name; must match the table name as it is stored in the database
    Returns:
      `ResultSet` - each row is a primary key column description
    Throws:
      `SQLException` - if a database access error occurs

  - ### getImportedKeys

    public ResultSet getImportedKeys(String catalog, String schema, String table) throws SQLException
    Gets a description of the primary key columns that are referenced by a table's foreign key columns. This method is not supported.
    Specified by:
      `getImportedKeys` in interface `DatabaseMetaData`
    Throws:
      `SQLException` - This exception is always thrown.

  - ### getExportedKeys

    public ResultSet getExportedKeys(String catalog, String schema, String table) throws SQLException
    Gets a description of a foreign key columns that reference a table's primary key columns. This method is not supported.
    Specified by:
      `getExportedKeys` in interface `DatabaseMetaData`
    Throws:
      `SQLException` - This exception is always thrown.

  - ### getCrossReference

    public ResultSet getCrossReference(String primaryCatalog, String primarySchema, String primaryTable, String foreignCatalog, String foreignSchema, String foreignTable) throws SQLException
    Gets a description of the foreign key columns in the foreign key table that reference the primary key columns of the primary key table. This method is not supported.
    Specified by:
      `getCrossReference` in interface `DatabaseMetaData`
    Throws:
      `SQLException` - This exception is always thrown.

  - ### getTypeInfo

    public ResultSet getTypeInfo() throws SQLException
    Gets a description of all the standard SQL types supported by this database. They are ordered by DATA_TYPE and then by how closely the data type maps to the corresponding JDBC SQL type.

    Each type description has the following columns:

    Column name | Data type | Description
    --- | --- | ---
    TYPE_NAME | String | Type name
    DATA_TYPE | short | SQL data type from java.sql.Types
    PRECISION | int | maximum precision
    LITERAL_PREFIX | String | prefix used to quote a literal (may be null)
    LITERAL_SUFFIX | String | suffix used to quote a literal (may be null)
    CREATE_PARAMS | String | parameters used in creating the type (may be null)
    NULLABLE | short | can you use NULL for this type ? typeNullable - allows NULL values typeNullableUnknown - nullability unknown
    CASE_SENSITIVE | boolean | is it case sensitive ?
    SEARCHABLE | short | can you use "WHERE" based on this type: typePredNone - No support typePredChar - Only supported with WHERE .. LIKE typePredBasic - Supported except for WHERE .. LIKE typeSearchable - Supported for all WHERE ..
    UNSIGNED_ATTRIBUTE | boolean | is it unsigned ?
    FIXED_PREC_SCALE | boolean | can it be a money value ?
    AUTO_INCREMENT | boolean | can it be used for an auto-increment value ?
    LOCAL_TYPE_NAME | String | Localized version of type name (may be null)
    MINIMUM_SCALE | short | minimum scale supported
    MAXIMUM_SCALE | short | maximum scale supported
    SQL_DATA_TYPE | int | unused
    SQL_DATETIME_SUB | int | unused
    NUM_PREC_RADIX | int | usually 2 or 10

    Specified by:
      `getTypeInfo` in interface `DatabaseMetaData`
    Returns:
      ResultSet in which each row is an SQL type definition.
    Throws:
      `SQLException` - This exception is required by the interface, but it is never thrown.

  - ### getIndexInfo

    public ResultSet getIndexInfo(String catalog, String schema, String table, boolean unique, boolean approximate) throws SQLException
    Retrieves a description of the given table's indices and statistics. They are ordered by NON_UNIQUE, TYPE, INDEX_NAME, and ORDINAL_POSITION.

    Each index column description has the following columns:

    1. TABLE_CAT String => table catalog (may be `null`)
    2. TABLE_SCHEM String => table schema (may be `null`)
    3. TABLE_NAME String => table name
    4. NON_UNIQUE boolean => Can index values be non-unique. false when TYPE is tableIndexStatistic
    5. INDEX_QUALIFIER String => index catalog (may be `null`); `null` when TYPE is tableIndexStatistic
    6. INDEX_NAME String => index name; `null` when TYPE is tableIndexStatistic
    7. TYPE short => index type:
       - tableIndexStatistic - this identifies table statistics that are returned in conjunction with a table's index descriptions
       - tableIndexClustered - this is a clustered index
       - tableIndexHashed - this is a hashed index
       - tableIndexOther - this is some other style of index
    8. ORDINAL_POSITION short => column sequence number within index; zero when TYPE is tableIndexStatistic
    9. COLUMN_NAME String => column name; `null` when TYPE is tableIndexStatistic
    10. ASC_OR_DESC String => column sort sequence, "A" => ascending, "D" => descending, may be `null` if sort sequence is not supported; `null` when TYPE is tableIndexStatistic
    11. CARDINALITY int => When TYPE is tableIndexStatistic, then this is the number of rows in the table; otherwise, it is the number of unique values in the index.
    12. PAGES int => When TYPE is tableIndexStatisic then this is the number of pages used for the table, otherwise it is the number of pages used for the current index.
    13. FILTER_CONDITION String => Filter condition, if any. (may be `null`)
    Specified by:
      `getIndexInfo` in interface `DatabaseMetaData`
    Parameters:
      `catalog` - a catalog name; must match the catalog name as it is stored in this database; "" retrieves those without a catalog; `null` means that the catalog name should not be used to narrow the search
      `schema` - a schema name; must match the schema name as it is stored in this database; "" retrieves those without a schema; `null` means that the schema name should not be used to narrow the search
      `table` - a table name; must match the table name as it is stored in this database
      `unique` - when true, return only indices for unique values; when false, return indices regardless of whether unique or not
      `approximate` - when true, result is allowed to reflect approximate or out of data values; when false, results are requested to be accurate
    Returns:
      `ResultSet` - each row is an index column description
    Throws:
      `SQLException` - if a database access error occurs

  - ### supportsResultSetType

    public boolean supportsResultSetType(int type) throws SQLException
    JDBC 2.0 Determines if the database supports the given result set type.
    Specified by:
      `supportsResultSetType` in interface `DatabaseMetaData`
    Parameters:
      `type` - The type defined in java.sql.ResultSet
    Returns:
      True if the type is TYPE_SCROLL_INSENSITIVE or TYPE_FORWARD_ONLY, else, returns False.
    Throws:
      `SQLException` - This exception is required by the interface but it is never thrown.
    See Also:
      - `MVAConnection`

  - ### supportsResultSetConcurrency

    public boolean supportsResultSetConcurrency(int type, int concurrency) throws SQLException
    JDBC 2.0 Determines if the database supports the concurrency type in combination with the given result set type.
    Specified by:
      `supportsResultSetConcurrency` in interface `DatabaseMetaData`
    Parameters:
      `type` - The type defined in java.sql.ResultSet.
      `concurrency` - type The concurrency type defined in java.sql.ResultSet.
    Returns:
      True if the resultset type is TYPE_SCROLL_INSENSITIVE or TYPE_FORWARD_ONLY and if the concurrency type is CONCUR_UPDATABLE or CONCUR_READ_ONLY, else returns False.
    Throws:
      `SQLException` - This exception is required by the interface but it is never thrown.
    See Also:
      - `MVAConnection`

  - ### ownUpdatesAreVisible

    public boolean ownUpdatesAreVisible(int type) throws SQLException
    JDBC 2.0 Determines whether a result set's own changes are visible.
    Specified by:
      `ownUpdatesAreVisible` in interface `DatabaseMetaData`
    Parameters:
      `type` - The type defined in java.sql.ResultSet.
    Returns:
      `true` Own changes are visible.
    Throws:
      `SQLException` - This exception is required by the interface but it is never thrown.

  - ### ownDeletesAreVisible

    public boolean ownDeletesAreVisible(int type) throws SQLException
    JDBC 2.0 Determines whether a result set's own changes are visible.
    Specified by:
      `ownDeletesAreVisible` in interface `DatabaseMetaData`
    Parameters:
      `type` - The type defined in java.sql.ResultSet.
    Returns:
      `true` Own changes are visible.
    Throws:
      `SQLException` - This exception is required by the interface but it is never thrown.

  - ### ownInsertsAreVisible

    public boolean ownInsertsAreVisible(int type) throws SQLException
    JDBC 2.0 Determines whether a result set's own changes are visible.
    Specified by:
      `ownInsertsAreVisible` in interface `DatabaseMetaData`
    Parameters:
      `type` - The type defined in java.sql.ResultSet.
    Returns:
      `true` Own changes are visible.
    Throws:
      `SQLException` - This exception is required by the interface but it is never thrown.

  - ### othersUpdatesAreVisible

    public boolean othersUpdatesAreVisible(int type) throws SQLException
    JDBC 2.0 Determines whether changes made by others are visible.
    Specified by:
      `othersUpdatesAreVisible` in interface `DatabaseMetaData`
    Parameters:
      `type` - The type defined in java.sql.ResultSet.
    Returns:
      `false` Own changes are visible.
    Throws:
      `SQLException` - This exception is required by the interface but it is never thrown.

  - ### othersDeletesAreVisible

    public boolean othersDeletesAreVisible(int type) throws SQLException
    JDBC 2.0 Determines whether changes made by others are visible.
    Specified by:
      `othersDeletesAreVisible` in interface `DatabaseMetaData`
    Parameters:
      `type` - The type defined in java.sql.ResultSet.
    Returns:
      `false` Own changes are visible.
    Throws:
      `SQLException` - This exception is required by the interface but it is never thrown.

  - ### othersInsertsAreVisible

    public boolean othersInsertsAreVisible(int type) throws SQLException
    JDBC 2.0 Determines whether changes made by others are visible.
    Specified by:
      `othersInsertsAreVisible` in interface `DatabaseMetaData`
    Parameters:
      `type` - The type defined in java.sql.ResultSet.
    Returns:
      `false` Own changes are visible.
    Throws:
      `SQLException` - This exception is required by the interface but it is never thrown.

  - ### updatesAreDetected

    public boolean updatesAreDetected(int type) throws SQLException
    JDBC 2.0 Determines whether or not a visible row update can be detected by calling ResultSet.rowUpdated().
    Specified by:
      `updatesAreDetected` in interface `DatabaseMetaData`
    Parameters:
      `type` - The type defined in java.sql.ResultSet.
    Returns:
      `false` Own changes are visible.
    Throws:
      `SQLException` - This exception is required by the interface but it is never thrown.

  - ### deletesAreDetected

    public boolean deletesAreDetected(int type) throws SQLException
    JDBC 2.0 Determines whether or not a visible row delete can be detected by calling ResultSet.rowDeleted(). If deletesAreDetected() returns false, then deleted rows are removed from the result set.
    Specified by:
      `deletesAreDetected` in interface `DatabaseMetaData`
    Parameters:
      `type` - The type defined in java.sql.ResultSet.
    Returns:
      `false` Own changes are visible.
    Throws:
      `SQLException` - This exception is required by the interface but it is never thrown.

  - ### insertsAreDetected

    public boolean insertsAreDetected(int type) throws SQLException
    JDBC 2.0 Determines whether or not a visible row insert can be detected by calling ResultSet.rowInserted().
    Specified by:
      `insertsAreDetected` in interface `DatabaseMetaData`
    Parameters:
      `type` - The type defined in java.sql.ResultSet.
    Returns:
      `false` Own changes are visible.
    Throws:
      `SQLException` - This exception is required by the interface but it is never thrown.

  - ### supportsBatchUpdates

    public boolean supportsBatchUpdates() throws SQLException
    JDBC 2.0 Determines if the database supports batch updates.
    Specified by:
      `supportsBatchUpdates` in interface `DatabaseMetaData`
    Returns:
      `true` Batch updates are supported as sequential queuing of update calls.
    Throws:
      `SQLException` - This exception is required by the interface but it is never thrown.

  - ### getUDTs

    public ResultSet getUDTs(String catalog, String schemaPattern, String typeNamePattern, int[] types) throws SQLException
    JDBC 2.0 Gets a description of the user-defined types defined in a particular schema. Schema specific UDTs may have type JAVA_OBJECT, STRUCT, or DISTINCT.
    Specified by:
      `getUDTs` in interface `DatabaseMetaData`
    Parameters:
      `catalog` - a catalog name; "" retrieves those without a catalog; null means drop catalog name from the selection criteria
      `schemaPattern` - a schema name pattern; "" retrieves those without a schema
      `typeNamePattern` - a type name pattern; may be a fully qualified name
      `types` - a list of user-named types to include (JAVA_OBJECT, STRUCT, or DISTINCT); null returns all types
    Returns:
      An empty ResultSet object.
    Throws:
      `SQLException` - This exception is required by the interface but it is never thrown.

  - ### getConnection

    public Connection getConnection() throws SQLException
    JDBC 2.0 Gets the connection that produced this metadata object.
    Specified by:
      `getConnection` in interface `DatabaseMetaData`
    Returns:
      An MVAConnection object.
    Throws:
      `SQLException` - This exception is required by the interface but it is never thrown.

  - ### getAttributes

    public ResultSet getAttributes(String catalog, String schemaPattern, String typeNamePattern, String attributeNamePattern) throws SQLException
    Retrieves a description of the given attribute of the given type for a user-defined type (UDT) that is available in the given schema and catalog. Empty method implementation for JDK1.4 compliance.
    Specified by:
      `getAttributes` in interface `DatabaseMetaData`
    Throws:
      `SQLException` - This exception is always thrown to indicate the method is not implemented.

  - ### getDatabaseMajorVersion

    public int getDatabaseMajorVersion() throws SQLException
    Retrieves the major version number of the underlying database.
    Specified by:
      `getDatabaseMajorVersion` in interface `DatabaseMetaData`
    Returns:
      the underlying database's major version
    Throws:
      `SQLException` - if a database access error occurs
    Since:
      1.4

  - ### getDatabaseMinorVersion

    public int getDatabaseMinorVersion() throws SQLException
    Retrieves the minor version number of the underlying database.
    Specified by:
      `getDatabaseMinorVersion` in interface `DatabaseMetaData`
    Returns:
      underlying database's minor version
    Throws:
      `SQLException` - if a database access error occurs
    Since:
      1.4

  - ### getJDBCMajorVersion

    public int getJDBCMajorVersion() throws SQLException
    Retrieves the major JDBC version number for this driver.
    Specified by:
      `getJDBCMajorVersion` in interface `DatabaseMetaData`
    Returns:
      JDBC version major number
    Throws:
      `SQLException` - if a database access error occurs
    Since:
      1.4

  - ### getJDBCMinorVersion

    public int getJDBCMinorVersion() throws SQLException
    Retrieves the minor JDBC version number for this driver.
    Specified by:
      `getJDBCMinorVersion` in interface `DatabaseMetaData`
    Returns:
      JDBC version major number
    Throws:
      `SQLException` - if a database access error occurs
    Since:
      1.4

  - ### getResultSetHoldability

    public int getResultSetHoldability() throws SQLException
    Specified by:
      `getResultSetHoldability` in interface `DatabaseMetaData`
    Throws:
      `SQLException`

  - ### getSQLStateType

    public int getSQLStateType() throws SQLException
    Specified by:
      `getSQLStateType` in interface `DatabaseMetaData`
    Throws:
      `SQLException`

  - ### getSuperTables

    public ResultSet getSuperTables(String catalog, String schemaPattern, String tableNamePattern) throws SQLException
    Retrieves a description of the table hierarchies defined in a particular schema in this database. Empty method implementation for JDK1.4 compliance.
    Specified by:
      `getSuperTables` in interface `DatabaseMetaData`
    Throws:
      `SQLException` - This exception is always thrown to indicate the method is not implemented.

  - ### getSuperTypes

    public ResultSet getSuperTypes(String catalog, String schemaPattern, String typeNamePattern) throws SQLException
    Retrieves a description of the user-defined type (UDT) hierarchies defined in a particular schema in this database. Empty method implementation for JDK1.4 compliance.
    Specified by:
      `getSuperTypes` in interface `DatabaseMetaData`
    Throws:
      `SQLException` - This exception is always thrown to indicate the method is not implemented.

  - ### locatorsUpdateCopy

    public boolean locatorsUpdateCopy() throws SQLException
    Specified by:
      `locatorsUpdateCopy` in interface `DatabaseMetaData`
    Throws:
      `SQLException`

  - ### supportsGetGeneratedKeys

    public boolean supportsGetGeneratedKeys() throws SQLException
    Specified by:
      `supportsGetGeneratedKeys` in interface `DatabaseMetaData`
    Throws:
      `SQLException`

  - ### supportsMultipleOpenResults

    public boolean supportsMultipleOpenResults() throws SQLException
    Specified by:
      `supportsMultipleOpenResults` in interface `DatabaseMetaData`
    Throws:
      `SQLException`

  - ### supportsNamedParameters

    public boolean supportsNamedParameters() throws SQLException
    Specified by:
      `supportsNamedParameters` in interface `DatabaseMetaData`
    Throws:
      `SQLException`

  - ### supportsResultSetHoldability

    public boolean supportsResultSetHoldability(int holdability) throws SQLException
    Specified by:
      `supportsResultSetHoldability` in interface `DatabaseMetaData`
    Throws:
      `SQLException`

  - ### supportsSavepoints

    public boolean supportsSavepoints() throws SQLException
    Specified by:
      `supportsSavepoints` in interface `DatabaseMetaData`
    Throws:
      `SQLException`

  - ### supportsStatementPooling

    public boolean supportsStatementPooling() throws SQLException
    Specified by:
      `supportsStatementPooling` in interface `DatabaseMetaData`
    Throws:
      `SQLException`

  - ### getRowIdLifetime

    public RowIdLifetime getRowIdLifetime() throws SQLException
    Specified by:
      `getRowIdLifetime` in interface `DatabaseMetaData`
    Throws:
      `SQLException`

  - ### getSchemas

    public ResultSet getSchemas(String catalog, String schemaPattern) throws SQLException
    Specified by:
      `getSchemas` in interface `DatabaseMetaData`
    Throws:
      `SQLException`

  - ### supportsStoredFunctionsUsingCallSyntax

    public boolean supportsStoredFunctionsUsingCallSyntax() throws SQLException
    Specified by:
      `supportsStoredFunctionsUsingCallSyntax` in interface `DatabaseMetaData`
    Throws:
      `SQLException`

  - ### autoCommitFailureClosesAllResultSets

    public boolean autoCommitFailureClosesAllResultSets() throws SQLException
    Specified by:
      `autoCommitFailureClosesAllResultSets` in interface `DatabaseMetaData`
    Throws:
      `SQLException`

  - ### getClientInfoProperties

    public ResultSet getClientInfoProperties() throws SQLException
    The `MVADatabaseMetaData` implementation of `getClientInfoProperties` always returns an empty result set. The IOM JDBC Driver does not support the ability to set or retrieve client info properties.

    Specified by:
      `getClientInfoProperties` in interface `DatabaseMetaData`
    Throws:
      `SQLException`

  - ### getFunctions

    public ResultSet getFunctions(String catalog, String schemaPattern, String functionNamePattern) throws SQLException
    This method is not supported.

    Retrieves a description of the system and user functions available in the given catalog.

    Only system and user function descriptions matching the schema and function name criteria are returned. They are ordered by `FUNCTION_CAT`, `FUNCTION_SCHEM`, `FUNCTION_NAME` and `SPECIFIC_ NAME`.

    Each function description has the the following columns:

    1. FUNCTION_CAT String => function catalog (may be `null`)
    2. FUNCTION_SCHEM String => function schema (may be `null`)
    3. FUNCTION_NAME String => function name. This is the name used to invoke the function
    4. REMARKS String => explanatory comment on the function
    5. FUNCTION_TYPE short => kind of function:
       - functionResultUnknown - Cannot determine if a return value or table will be returned
       - functionNoTable- Does not return a table
       - functionReturnsTable - Returns a table
    6. SPECIFIC_NAME String => the name which uniquely identifies this function within its schema. This is a user specified, or DBMS generated, name that may be different then the `FUNCTION_NAME` for example with overload functions

    A user may not have permission to execute any of the functions that are returned by `getFunctions`

    Specified by:
      `getFunctions` in interface `DatabaseMetaData`
    Parameters:
      `catalog` - a catalog name; must match the catalog name as it is stored in the database; "" retrieves those without a catalog; `null` means that the catalog name should not be used to narrow the search
      `schemaPattern` - a schema name pattern; must match the schema name as it is stored in the database; "" retrieves those without a schema; `null` means that the schema name should not be used to narrow the search
      `functionNamePattern` - a function name pattern; must match the function name as it is stored in the database

    Throws:
      `SQLException` - Always thrown, to indicate that this method is not implemented.

    Since:
      1.6
    See Also:
      - `getSearchStringEscape()`

  - ### getFunctionColumns

    public ResultSet getFunctionColumns(String catalog, String schemaPattern, String functionNamePattern, String columnNamePattern) throws SQLException
    This method is not supported.

    Retrieves a description of the given catalog's system or user function parameters and return type.

    Only descriptions matching the schema, function and parameter name criteria are returned. They are ordered by `FUNCTION_CAT`, `FUNCTION_SCHEM`, `FUNCTION_NAME` and `SPECIFIC_ NAME`. Within this, the return value, if any, is first. Next are the parameter descriptions in call order. The column descriptions follow in column number order.

    Each row in the `ResultSet` is a parameter description, column description or return type description with the following fields:

    1. FUNCTION_CAT String => function catalog (may be `null`)
    2. FUNCTION_SCHEM String => function schema (may be `null`)
    3. FUNCTION_NAME String => function name. This is the name used to invoke the function
    4. COLUMN_NAME String => column/parameter name
    5. COLUMN_TYPE Short => kind of column/parameter:
       - functionColumnUnknown - nobody knows
       - functionColumnIn - IN parameter
       - functionColumnInOut - INOUT parameter
       - functionColumnOut - OUT parameter
       - functionColumnReturn - function return value
       - functionColumnResult - Indicates that the parameter or column is a column in the `ResultSet`
    6. DATA_TYPE int => SQL type from java.sql.Types
    7. TYPE_NAME String => SQL type name, for a UDT type the type name is fully qualified
    8. PRECISION int => precision
    9. LENGTH int => length in bytes of data
    10. SCALE short => scale - null is returned for data types where SCALE is not applicable.
    11. RADIX short => radix
    12. NULLABLE short => can it contain NULL.
        - functionNoNulls - does not allow NULL values
        - functionNullable - allows NULL values
        - functionNullableUnknown - nullability unknown
    13. REMARKS String => comment describing column/parameter
    14. CHAR_OCTET_LENGTH int => the maximum length of binary and character based parameters or columns. For any other datatype the returned value is a NULL
    15. ORDINAL_POSITION int => the ordinal position, starting from 1, for the input and output parameters. A value of 0 is returned if this row describes the function's return value. For result set columns, it is the ordinal position of the column in the result set starting from 1.
    16. IS_NULLABLE String => ISO rules are used to determine the nullability for a parameter or column.
        - YES --- if the parameter or column can include NULLs
        - NO --- if the parameter or column cannot include NULLs
        - empty string --- if the nullability for the parameter or column is unknown
    17. SPECIFIC_NAME String => the name which uniquely identifies this function within its schema. This is a user specified, or DBMS generated, name that may be different then the `FUNCTION_NAME` for example with overload functions

    The PRECISION column represents the specified column size for the given parameter or column. For numeric data, this is the maximum precision. For character data, this is the length in characters. For datetime datatypes, this is the length in characters of the String representation (assuming the maximum allowed precision of the fractional seconds component). For binary data, this is the length in bytes. For the ROWID datatype, this is the length in bytes. Null is returned for data types where the column size is not applicable.

    Specified by:
      `getFunctionColumns` in interface `DatabaseMetaData`
    Parameters:
      `catalog` - a catalog name; must match the catalog name as it is stored in the database; "" retrieves those without a catalog; `null` means that the catalog name should not be used to narrow the search
      `schemaPattern` - a schema name pattern; must match the schema name as it is stored in the database; "" retrieves those without a schema; `null` means that the schema name should not be used to narrow the search
      `functionNamePattern` - a procedure name pattern; must match the function name as it is stored in the database
      `columnNamePattern` - a parameter name pattern; must match the parameter or column name as it is stored in the database

    Throws:
      `SQLException` - Always thrown, to indicate that this method is not implemented.

    Since:
      1.6
    See Also:
      - `getSearchStringEscape()`

  - ### unwrap

    public <T> T unwrap(Class<T> iface) throws SQLException
    Specified by:
      `unwrap` in interface `Wrapper`
    Throws:
      `SQLException`

  - ### isWrapperFor

    public boolean isWrapperFor(Class<?> iface) throws SQLException
    Specified by:
      `isWrapperFor` in interface `Wrapper`
    Throws:
      `SQLException`

  - ### generatedKeyAlwaysReturned

    public boolean generatedKeyAlwaysReturned() throws SQLException
    Specified by:
      `generatedKeyAlwaysReturned` in interface `DatabaseMetaData`
    Throws:
      `SQLException`

  - ### getPseudoColumns

    public ResultSet getPseudoColumns(String arg0, String arg1, String arg2, String arg3) throws SQLException
    Specified by:
      `getPseudoColumns` in interface `DatabaseMetaData`
    Throws:
      `SQLException`